﻿/*
	"Solid Duration" v.1	Created by: David Torno ©2009 04/25/09
	
	This script was created at the request of Brandon Parvini of Ghost Town Media.
	
	This script will:
	- Create a solid
	- Let the user choose the color
	- Place the new solid underneath the selected layer in the timeline
	- Automatically trim solid layer to the same in and out points of selected layer
	
	This script is primarily for creating backdrop solids for footage that has transparency.
*/

{
function solDuration(thisObj) {
	function solDuration_buildUI(thisObj) {//legend...........................('Window type', 'Name of palette', [left edge, top edge, right edge, bottom edge];
		var myPanel = (thisObj instanceof Panel) ? thisObj : new Window("palette", "Solid Duration", [100, 100, 270, 140]);

//Jeff Almasol's solution to fix text color	——————————————————————————————————————————
		var winGfx = myPanel.graphics;
		var darkColorBrush = winGfx.newPen(winGfx.BrushType.SOLID_COLOR, [0,0,0], 1);

//PANEL	CREATE BUTTON	———————————————————————————————————————————————
		myPanel.createBut = myPanel.add("button", [10, 10, 120, 30], "Create Solid");
		myPanel.createBut.onClick = solDur;
		
		myPanel.aboutBut = myPanel.add("button", [130, 10, 150, 30], "?");
		myPanel.aboutBut.onClick = function () {alert(helpButText);}
		
		return myPanel;	//ends the addition of interface additions like buttons, boxes, sliders, etc...
	}

//	ABOUT	———————————————————————————————————————————————————
		var helpButText = "\"Solid Duration\"	©2009\n\n"+
	"Created by: David Torno     www.aeioweyou.blogspot.com\n\n"+
	"This script was created at the request of Brandon Parvini\n"+
	"of Ghost Town Media.\n"+
	"\n"+
	"Some code snippits were borrowed from \"TrackerViz.jsx\" and \"TAdj_Trimmed Adj Layer.jsx\" and were credited accordingly within the script.\n"+
	"\n"+
	"HOW TO USE:\n"+
	"To use this script, select the layer or layers that you want to add a solid below, then click \"Create Solid\" button. You will then be asked to choose a color for each solid as they are created.\n"+
	"\n"+
	"By default the new solid will be named the same as the selected layer plus the word \"Backdrop\". For example: \"My Layer\" will have a solid named \"My Layer Backdrop\".\n";
//	"\n"+
//	"\n"+
//	"\n"+
//	"\n";


//FUNCTION	CREATE SOLID	———————————————————————————————————————————————
	function solDur() {	//starts "dupIt" function of "butThree" button

		var myComp = app.project.activeItem;	//Create variable to house active composition

		if(myComp instanceof CompItem) {	//Checks to see if selected comp actually is a comp

			app.beginUndoGroup("Solid Duration");	//starts the undo group

			//Selected layers loop
			var myLayers = myComp.selectedLayers;
			for (var i = 0; i < myLayers.length; i++) {

			var myLayer = myLayers[i];

			var compWidth = myComp.width;
			var compHeight = myComp.height;
			var compPAR = myComp.pixelAspect;

			var layerInPoint = myLayer.inPoint;
			var layerOutPoint = myLayer.outPoint;
			var selName = myLayer.name;
			var selLayerDur = myLayer.duration;
			var fps = myComp.frameRate;
			var layerIndex = myLayer.index;
			var defaultColor = [0, 0, 0];
			//————————————————————————————————————————————————————————————
			//Color picker was used from the TrackerViz script created by www.nabscripts.com
			var colorInt = 255 * (65536 * defaultColor[0] + 256 * defaultColor[1] + defaultColor[2]);
			var c = $.colorPicker(colorInt);    // open color selection dialog
			if (c == -1) return;	//Cancel button clicked
			var r = ((c >> 16) & 0xFF) / 255;
			var g = ((c >> 8) & 0xFF) / 255;
			var b = (c & 0xFF) / 255;
			//————————————————————————————————————————————————————————————

			var layerName = selName + " backdrop";

			var newSolid = myComp.layers.addSolid([r, g, b], layerName, compWidth, compHeight, compPAR);

			//————————————————————————————————————————————————————————————
			//Got this snippet from the Trimmed Adj Layer script by Lloyd Alvarez  http://aescripts.com
			newSolid.moveAfter(myComp.layer(layerIndex+1));
			//————————————————————————————————————————————————————————————

			newSolid.inPoint = layerInPoint;	//works solo
			newSolid.outPoint = layerOutPoint;	//works solo

			}
			app.endUndoGroup();	//ends the undo group
				if (myComp.selectedLayers <= 0){
				alert ('Please select a layer.');
				}
		}
	}

//	SHOW PANEL WINDOW	———————————————————————————————————————————————
	var solDurPal = solDuration_buildUI(thisObj);	//variable to hold the Panel object

	if ((solDurPal != null) && (solDurPal instanceof Window)) {	//checks if panel is a window
		solDurPal.center();
		solDurPal.show();	//show a window instead
		}
	}

//	SHOW DOCKABLE PANEL	———————————————————————————————————————————————
	solDuration(this);	//show the dockable Panel
}